module LMaybe (LMaybe(..),GHt_LMaybe,ghEP_LMaybe,GHC_LNothing,GHC_LJust,GHt_GHC_LNothing,GHt_GHC_LJust,ghEP_GHC_LNothing,ghEP_GHC_LJust)
  where
import Prelude 
import GHPrelude 
import qualified Prelude as GHM_Prelude 
import qualified GHPrelude as GHM_GHPrelude 

-- LMaybe :: (* -> *) -> * -> *
data LMaybe f a  = LNothing | LJust (f a)
type GHC_LNothing f a  = LMaybe f a
type GHC_LJust f a  = LMaybe f a

-- structure type for LMaybe
type GHt_LMaybe f a  = GHPrelude.Sum (GHPrelude.Con (GHC_LNothing f a)) (GHPrelude.Con (GHC_LJust f a))
type GHt_GHC_LNothing f a  = GHPrelude.Unit
type GHt_GHC_LJust f a  = f a

-- EP pair for LMaybe
ghEP_LMaybe :: GHPrelude.EP (LMaybe f a) (GHt_LMaybe f a)
ghEP_LMaybe  = let gh_From gh_A@LNothing = GHPrelude.Inl (GHPrelude.Con gh_A)
                   gh_From gh_A@(LJust gh_a) = GHPrelude.Inr (GHPrelude.Con gh_A)
                   gh_To (GHPrelude.Inl (GHPrelude.Con gh_A)) = gh_A
                   gh_To (GHPrelude.Inr (GHPrelude.Con gh_A)) = gh_A
               in  GHPrelude.EP gh_From gh_To

ghEP_GHC_LNothing :: GHPrelude.EP (GHC_LNothing f a) GHPrelude.Unit
ghEP_GHC_LNothing  = let gh_From LNothing = GHPrelude.Unit
                         gh_To GHPrelude.Unit = LNothing
                     in  GHPrelude.EP gh_From gh_To

ghEP_GHC_LJust :: GHPrelude.EP (GHC_LJust f a) (GHt_GHC_LJust f a)
ghEP_GHC_LJust  = let gh_From (LJust gh_a) = gh_a
                      gh_To gh_a = LJust gh_a
                  in  GHPrelude.EP gh_From gh_To


-- normal/MPC specialisations

-- generic abstraction specialisations

-- type-indexed type specialisations
